diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/empty/ChunkDecoratorEmpty.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/empty/ChunkDecoratorEmpty.java
index 2fbafffa9..8376e7b5f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/empty/ChunkDecoratorEmpty.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/empty/ChunkDecoratorEmpty.java
@@ -10,7 +10,7 @@ public class ChunkDecoratorEmpty
     @Override
     public void decorate(Chunk chunk)
     {
-        if (chunk.xPosition == 0 && chunk.zPosition == 0)
+        if (chunk.pos.x == 0 && chunk.pos.z == 0)
         {
             chunk.setBlockID(0, 0, 0, Blocks.BEDROCK.id());
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/ChunkGeneratorIndev.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/ChunkGeneratorIndev.java
index a490a6f92..9073d64aa 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/ChunkGeneratorIndev.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/ChunkGeneratorIndev.java
@@ -31,8 +31,8 @@ public class ChunkGeneratorIndev
     {
         ChunkGeneratorResult result = new ChunkGeneratorResult();
 
-        int chunkX = chunk.xPosition;
-        int chunkZ = chunk.zPosition;
+        int chunkX = chunk.pos.x;
+        int chunkZ = chunk.pos.z;
 
         lg.generate(world, result, chunkX * Chunk.CHUNK_SIZE_X, chunkZ * Chunk.CHUNK_SIZE_Z);
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/ChunkGeneratorPerlin.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/ChunkGeneratorPerlin.java
index 59acb350e..eccb5ddb1 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/ChunkGeneratorPerlin.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/ChunkGeneratorPerlin.java
@@ -36,7 +36,7 @@ public class ChunkGeneratorPerlin
         ChunkGeneratorResult result = terrainGenerator.generateTerrain(chunk, densityMap);
         surfaceGenerator.generateSurface(chunk, result);
         for (LargeFeature largeFeature : largeFeatures) {
-            largeFeature.generate(world, chunk.xPosition, chunk.zPosition, result);
+            largeFeature.generate(world, chunk.pos.x, chunk.pos.z, result);
         }
 
         return result;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/TerrainGeneratorLerp.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/TerrainGeneratorLerp.java
index 95f030f9d..227e6d6a0 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/TerrainGeneratorLerp.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/TerrainGeneratorLerp.java
@@ -25,7 +25,7 @@ public abstract class TerrainGeneratorLerp
     {
         int terrainHeight = (world.getWorldType().getMaxY() + 1) - world.getWorldType().getMinY();
 
-        rand.setSeed((long) chunk.xPosition * 0x4F9939F508L + (long) chunk.zPosition * 0x1EF1565BD5L);
+        rand.setSeed((long) chunk.pos.x * 0x4F9939F508L + (long) chunk.pos.z * 0x1EF1565BD5L);
 
         // Number of blocks per chunk.
         final int xBlocksPerChunk = Chunk.CHUNK_SIZE_X;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/drift/DensityGeneratorDrift.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/drift/DensityGeneratorDrift.java
index 8e3b726d9..f379e4f54 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/drift/DensityGeneratorDrift.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/drift/DensityGeneratorDrift.java
@@ -35,9 +35,9 @@ public class DensityGeneratorDrift
         int xSize = 4 + 1;
         int ySize = (terrainHeight / 8) + 1;
         int zSize = 4 + 1;
-        int x = chunk.xPosition * 4;
+        int x = chunk.pos.x * 4;
         int y = 0;
-        int z = chunk.zPosition * 4;
+        int z = chunk.pos.z * 4;
 
         double[] densityMapArray = new double[xSize * ySize * zSize];
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
index 4122b4bc5..0dda34cd8 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
@@ -27,8 +27,8 @@ public class ChunkDecoratorNether
     @Override
     public void decorate(Chunk chunk)
     {
-        int chunkX = chunk.xPosition;
-        int chunkZ = chunk.zPosition;
+        int chunkX = chunk.pos.x;
+        int chunkZ = chunk.pos.z;
 
         int minY = world.getWorldType().getMinY();
         int maxY = world.getWorldType().getMaxY();
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
index bb68f8bda..d47ca2b9a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
@@ -75,9 +75,9 @@ public class DensityGeneratorNether
         int xSize = 4 + 1;
         int ySize = (terrainHeight / 8) + 1;
         int zSize = 4 + 1;
-        int x = chunk.xPosition * 4;
+        int x = chunk.pos.x * 4;
         int y = 0;
-        int z = chunk.zPosition * 4;
+        int z = chunk.pos.z * 4;
 
         int quarterYSize = ((terrainHeight / 4) / 8) + 1;
         int threeQuarterYSize = ((int) (terrainHeight * 0.75f) / 8) + 1;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
index 49223206e..96324187b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
@@ -30,8 +30,8 @@ public class SurfaceGeneratorNether
         int oceanY = world.getWorldType().getOceanY();
         int minY = world.getWorldType().getMinY();
         int maxY = world.getWorldType().getMaxY();
-        int chunkX = chunk.xPosition;
-        int chunkZ = chunk.zPosition;
+        int chunkX = chunk.pos.x;
+        int chunkZ = chunk.pos.z;
 
         int oceanBlock = world.getWorldType().getOceanBlockId();
         int worldFillBlock = world.getWorldType().getFillerBlockId();
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
index 71a31876d..38764c185 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
@@ -75,10 +75,10 @@ public class TerrainGeneratorNether
                 lastBiomePosZ = chunk.getBlockBiome(x, 0, z + 1);
             }
         }
-        if (lastChunkX != chunk.xPosition || lastChunkZ != chunk.zPosition) {
-            lastChunkX = chunk.xPosition;
-            lastChunkZ = chunk.zPosition;
-            noise.get(cache, chunk.xPosition * Chunk.CHUNK_SIZE_X, 0, chunk.zPosition * Chunk.CHUNK_SIZE_Z, Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, 0.2, 0.2, 0.2);
+        if (lastChunkX != chunk.pos.x || lastChunkZ != chunk.pos.z) {
+            lastChunkX = chunk.pos.x;
+            lastChunkZ = chunk.pos.z;
+            noise.get(cache, chunk.pos.x * Chunk.CHUNK_SIZE_X, 0, chunk.pos.z * Chunk.CHUNK_SIZE_Z, Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, 0.2, 0.2, 0.2);
 
             float avg = 0;
             for (int i = 0; i < cache.length; i++) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
index 63a25d670..0ac0bb076 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
@@ -47,8 +47,8 @@ public class ChunkDecoratorOverworld
     public void decorate(Chunk chunk)
     {
         world.scheduledUpdatesAreImmediate = true;
-        int chunkX = chunk.xPosition;
-        int chunkZ = chunk.zPosition;
+        int chunkX = chunk.pos.x;
+        int chunkZ = chunk.pos.z;
 
         int minY = world.getWorldType().getMinY();
         int maxY = world.getWorldType().getMaxY();
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/DensityGeneratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/DensityGeneratorOverworld.java
index 4d985b1bb..3097a4e04 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/DensityGeneratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/DensityGeneratorOverworld.java
@@ -165,9 +165,9 @@ public class DensityGeneratorOverworld
         int xSize = 4 + 1;
         int ySize = (terrainHeight / 8) + 1;
         int zSize = 4 + 1;
-        int x = chunk.xPosition * 4;
+        int x = chunk.pos.x * 4;
         int y = 0;
-        int z = chunk.zPosition * 4;
+        int z = chunk.pos.z * 4;
 
         double[] densityMapArray = new double[xSize * ySize * zSize];
 
@@ -304,8 +304,8 @@ public class DensityGeneratorOverworld
 
         if (generateRivers)
         {
-            modifyDensityMapSmoothingRivers(chunk.xPosition, chunk.zPosition, terrainHeight, densityMapArray);
-            modifyDensityMapCarvingRivers(chunk.xPosition, chunk.zPosition, terrainHeight, densityMapArray);
+            modifyDensityMapSmoothingRivers(chunk.pos.x, chunk.pos.z, terrainHeight, densityMapArray);
+            modifyDensityMapCarvingRivers(chunk.pos.x, chunk.pos.z, terrainHeight, densityMapArray);
         }
 
         return densityMapArray;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
index 62086b02e..5b19f7e02 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
@@ -49,8 +49,8 @@ public class SurfaceGeneratorOverworld
         int minY = world.getWorldType().getMinY();
         int maxY = world.getWorldType().getMaxY();
         int terrainHeight = (maxY + 1) - minY;
-        int chunkX = chunk.xPosition;
-        int chunkZ = chunk.zPosition;
+        int chunkX = chunk.pos.x;
+        int chunkZ = chunk.pos.z;
 
         int oceanBlock = world.getWorldType().getOceanBlockId();
         int worldFillBlock = world.getWorldType().getFillerBlockId();
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
index 432c9a201..316ad138b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
@@ -32,8 +32,8 @@ public class ChunkDecoratorOverworldB173
         this.world.scheduledUpdatesAreImmediate = true;
         BlockLogicSand.fallInstantly = true;
 
-        final int x = chunk.xPosition;
-        final int z = chunk.zPosition;
+        final int x = chunk.pos.x;
+        final int z = chunk.pos.z;
 
         final int minY = this.world.getWorldType().getMinY();
         final int maxY = this.world.getWorldType().getMaxY();
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java
index 52c6c1440..367024d93 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java
@@ -229,10 +229,10 @@ public class ChunkDecoratorOverworldHell
 
     @Override
     public void postDecorate(@NotNull final World world, @NotNull final Chunk chunk) {
-        final int chunkX = chunk.xPosition;
-        final int chunkZ = chunk.zPosition;
-        final int worldX = chunkX * 16;
-        final int worldZ = chunkZ * 16;
+        final int x = chunk.pos.x;
+        final int z = chunk.pos.z;
+        final int worldX = x * 16;
+        final int worldZ = z * 16;
 
         final int minY = world.getWorldType().getMinY();
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java
index b10498dcc..cbb5bea1e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java
@@ -39,8 +39,8 @@ public class ChunkDecoratorOverworldRetro
     public void decorate(Chunk chunk)
     {
         world.scheduledUpdatesAreImmediate = true;
-        int chunkX = chunk.xPosition;
-        int chunkZ = chunk.zPosition;
+        int chunkX = chunk.pos.x;
+        int chunkZ = chunk.pos.z;
 
         int minY = world.getWorldType().getMinY();
         int maxY = world.getWorldType().getMaxY();
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblock.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblock.java
index 28d803342..2f734c0e9 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblock.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblock.java
@@ -43,7 +43,7 @@ public class ChunkDecoratorSkyblock
     }
 
     private boolean contains(Chunk chunk, int xBlock, int zBlock) {
-        return chunk.xPosition == xBlock >> 4 && chunk.zPosition == zBlock >> 4;
+        return chunk.pos.x == xBlock >> 4 && chunk.pos.z == zBlock >> 4;
     }
 
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblockNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblockNether.java
index 465c27272..9ec3ab391 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblockNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblockNether.java
@@ -39,7 +39,7 @@ public class ChunkDecoratorSkyblockNether
     }
 
     private boolean contains(Chunk chunk, int xBlock, int zBlock) {
-        return chunk.xPosition == xBlock >> 4 && chunk.zPosition == zBlock >> 4;
+        return chunk.pos.x == xBlock >> 4 && chunk.pos.z == zBlock >> 4;
     }
 
     private void tryPlace(Chunk chunk, int xBlock, int yBlock, int zBlock, int blockId) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblock.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblock.java
index 553869805..559ff5511 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblock.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblock.java
@@ -55,7 +55,7 @@ public class ChunkGeneratorSkyblock
     }
 
     private boolean contains(Chunk chunk, int xBlock, int zBlock) {
-        return chunk.xPosition == xBlock >> 4 && chunk.zPosition == zBlock >> 4;
+        return chunk.pos.x == xBlock >> 4 && chunk.pos.z == zBlock >> 4;
     }
 
     private void tryPlace(Chunk chunk, ChunkGeneratorResult result, int xBlock, int yBlock, int zBlock, int blockId) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblockNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblockNether.java
index 3fe19c1dd..5111ca851 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblockNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblockNether.java
@@ -46,7 +46,7 @@ public class ChunkGeneratorSkyblockNether
     }
 
     private boolean contains(Chunk chunk, int xBlock, int zBlock) {
-        return chunk.xPosition == xBlock >> 4 && chunk.zPosition == zBlock >> 4;
+        return chunk.pos.x == xBlock >> 4 && chunk.pos.z == zBlock >> 4;
     }
 
     private void tryPlace(Chunk chunk, ChunkGeneratorResult result, int xBlock, int yBlock, int zBlock, int blockId) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMudPatch.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMudPatch.java
index 99a477556..46f213224 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMudPatch.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMudPatch.java
@@ -12,8 +12,8 @@ public class WorldFeatureMudPatch extends WorldFeature
 
     @Override
 	public boolean place(World world, Random random, int x, int y, int z) {
-        int chunkCoordX = world.getChunkFromBlockCoords(x, z).xPosition * 16;
-        int chunkCoordZ = world.getChunkFromBlockCoords(x, z).zPosition * 16;
+        int chunkCoordX = world.getChunkFromBlockCoords(x, z).pos.x * 16;
+        int chunkCoordZ = world.getChunkFromBlockCoords(x, z).pos.z * 16;
 
 
         for (int chunkX = chunkCoordX; chunkX < chunkCoordX + 16; chunkX++) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPos.java b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPos.java
index 296231e86..d3b7d675d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPos.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPos.java
@@ -1,12 +1,12 @@
 package net.minecraft.core.world.pos;
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.chunk.Chunk;
 import org.jetbrains.annotations.NotNull;
 
-public final class ChunkPos {
+public final class ChunkPos
+ implements Pos2i<ChunkPos> {
     public int x;
     public int z;
 
@@ -17,8 +17,8 @@ public final class ChunkPos {
 
     public ChunkPos(final @NotNull TilePos tilePos) {
         this(
-            MathHelper.floorIntDiv(tilePos.x, Chunk.CHUNK_SIZE_X),
-            MathHelper.floorIntDiv(tilePos.z, Chunk.CHUNK_SIZE_Z)
+            Math.floorDiv(tilePos.x, Chunk.CHUNK_SIZE_X),
+            Math.floorDiv(tilePos.z, Chunk.CHUNK_SIZE_Z)
         );
     }
 
@@ -29,32 +29,22 @@ public final class ChunkPos {
         );
     }
 
-    public @NotNull TilePos toTilePos(final @NotNull ChunkTilePos chunkTilePos) {
-        return new TilePos(this, chunkTilePos);
-    }
-
-    public @NotNull ChunkPos add(final int x, final int z) {
-        return new ChunkPos(this.x + x, this.z + z);
-    }
-
-    public @NotNull ChunkPos add(final @NotNull ChunkPos other) {
-        return new ChunkPos(this.x + other.x, this.z + other.z);
-    }
-
-    public @NotNull ChunkPos add(final @NotNull Direction direction, final int distance) {
-        return new ChunkPos(this.x + direction.getOffsetX() * distance, this.z + direction.getOffsetZ() * distance);
+    @Override
+    public int x() {
+        return this.x;
     }
 
-    public @NotNull ChunkPos add(final @NotNull Direction direction) {
-        return this.add(direction, 1);
+    @Override
+    public int z() {
+        return this.z;
     }
 
-    public @NotNull ChunkPos sub(final int x, final int z) {
-        return new ChunkPos(this.x - x, this.z - z);
+    public @NotNull ChunkPos add(final int x, final int z) {
+        return new ChunkPos(this.x + x, this.z + z);
     }
 
-    public @NotNull ChunkPos sub(final @NotNull ChunkPos other) {
-        return new ChunkPos(this.x - other.x, this.z - other.z);
+    public @NotNull TilePos toTilePos(final @NotNull ChunkTilePos chunkTilePos) {
+        return new TilePos(this, chunkTilePos);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkSectionTilePos.java b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkSectionTilePos.java
new file mode 100644
index 000000000..75ca95dc9
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkSectionTilePos.java
@@ -0,0 +1,87 @@
+package net.minecraft.core.world.pos;
+
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.chunk.ChunkSection;
+import org.jetbrains.annotations.NotNull;
+
+public class ChunkSectionTilePos
+    implements Pos3i<ChunkSectionTilePos> {
+    public int x;
+    public int y;
+    public int z;
+
+    public ChunkSectionTilePos(final int x, final int y, final int z) {
+        this.x = Integer.remainderUnsigned(x, Chunk.CHUNK_SIZE_X);
+        this.y = Integer.remainderUnsigned(y, ChunkSection.SECTION_SIZE_Y);
+        this.z = Integer.remainderUnsigned(z, Chunk.CHUNK_SIZE_Z);
+    }
+
+    public ChunkSectionTilePos(final float x, final float y, final float z) {
+        this(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z));
+    }
+
+    public ChunkSectionTilePos(final double x, final double y, final double z) {
+        this(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z));
+    }
+
+    public ChunkSectionTilePos(final @NotNull ChunkTilePos tilePos) {
+        this(tilePos.x, tilePos.y, tilePos.z);
+    }
+
+    public ChunkSectionTilePos(final @NotNull TilePos tilePos) {
+        this(tilePos.x, tilePos.y, tilePos.z);
+    }
+
+    public ChunkSectionTilePos(final @NotNull Vec3 vec) {
+        this(vec.x, vec.y, vec.z);
+    }
+
+    public ChunkSectionTilePos(final @NotNull Entity entity) {
+        this(entity.x, entity.y, entity.z);
+    }
+
+    @Override
+    public int x() {
+        return this.x;
+    }
+
+    @Override
+    public int y() {
+        return this.y;
+    }
+
+    @Override
+    public int z() {
+        return this.z;
+    }
+
+    @Override
+    public @NotNull ChunkSectionTilePos add(final int x, final int y, final int z) {
+        return new ChunkSectionTilePos(this.x + x, this.y + y, this.z + z);
+    }
+
+    public @NotNull ChunkTilePos toChunkTilePos(final int sectionIndex) {
+        return new ChunkTilePos(this.x, this.y + sectionIndex * ChunkSection.SECTION_SIZE_Y, this.z);
+    }
+
+    public boolean inBounds() {
+        return this.x >= 0 && this.x < Chunk.CHUNK_SIZE_X && this.y >= 0 && this.y < ChunkSection.SECTION_SIZE_Y && this.z >= 0 && this.z < Chunk.CHUNK_SIZE_Z;
+    }
+
+    @Override
+    public boolean equals(final Object obj) {
+        if (!(obj instanceof final @NotNull ChunkSectionTilePos other)) {
+            return false;
+        } else {
+            return this.x == other.x && this.y == other.y && this.z == other.z;
+        }
+    }
+
+    @Override
+    public int hashCode() {
+        return MathHelper.cantor(MathHelper.cantor(this.x, this.y), this.z);
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkTilePos.java b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkTilePos.java
index c579e6c2e..7a8a5571f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkTilePos.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkTilePos.java
@@ -1,14 +1,15 @@
 package net.minecraft.core.world.pos;
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.chunk.ChunkSection;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public final class ChunkTilePos {
+public final class ChunkTilePos
+    implements Pos3i<ChunkTilePos> {
     public int x;
     public int y;
     public int z;
@@ -39,32 +40,39 @@ public final class ChunkTilePos {
         this(entity.x, entity.y, entity.z);
     }
 
-    public @NotNull TilePos toTilePos(final @NotNull ChunkPos chunkPos) {
-        return new TilePos(chunkPos, this);
+    @Override
+    public int x() {
+        return this.x;
     }
 
-    public @NotNull ChunkTilePos add(final int x, final int y, final int z) {
-        return new ChunkTilePos(this.x + x, this.y + y, this.z + z);
+    @Override
+    public int y() {
+        return this.y;
     }
 
-    public @NotNull ChunkTilePos add(final @NotNull TilePos other) {
-        return new ChunkTilePos(this.x + other.x, this.y + other.y, this.z + other.z);
+    @Override
+    public int z() {
+        return this.z;
     }
 
-    public @NotNull ChunkTilePos add(final @NotNull Direction direction, final int distance) {
-        return new ChunkTilePos(this.x + direction.getOffsetX() * distance, this.y + direction.getOffsetY() * distance, this.z + direction.getOffsetZ() * distance);
+    public @NotNull ChunkTilePos add(final int x, final int y, final int z) {
+        return new ChunkTilePos(this.x + x, this.y + y, this.z + z);
+    }
+
+    public @NotNull TilePos toTilePos(final @NotNull ChunkPos chunkPos) {
+        return new TilePos(chunkPos, this);
     }
 
-    public @NotNull ChunkTilePos add(final @NotNull Direction direction) {
-        return this.add(direction, 1);
+    public @NotNull ChunkSectionTilePos toChunkSectionTilePos() {
+        return new ChunkSectionTilePos(this);
     }
 
-    public @NotNull ChunkTilePos sub(final int x, final int y, final int z) {
-        return new ChunkTilePos(this.x - x, this.y - y, this.z - z);
+    public boolean inBounds() {
+        return this.x >= 0 && this.x < Chunk.CHUNK_SIZE_X && this.y >= 0 && this.y < Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y && this.z >= 0 && this.z < Chunk.CHUNK_SIZE_Z;
     }
 
-    public @NotNull ChunkTilePos sub(final @NotNull TilePos other) {
-        return new ChunkTilePos(this.x - other.x, this.y - other.y, this.z - other.z);
+    public int getSectionIndex() {
+        return this.y / ChunkSection.SECTION_SIZE_Y;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/Pos2i.java b/game/core/src/main/java/net/minecraft/core/world/pos/Pos2i.java
new file mode 100644
index 000000000..57f454d2d
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/Pos2i.java
@@ -0,0 +1,47 @@
+package net.minecraft.core.world.pos;
+
+import net.minecraft.core.util.helper.Direction;
+import org.jetbrains.annotations.NotNull;
+
+public interface Pos2i<T extends Pos2i<T>> {
+    int x();
+    int z();
+
+    @NotNull T add(final int x, final int z);
+
+    default @NotNull T add(final @NotNull T other) {
+        return this.add(other.x(), other.z());
+    }
+
+    default @NotNull T add(final @NotNull Direction direction, final int distance) {
+        return this.add(direction.getOffsetX() * distance, direction.getOffsetZ() * distance);
+    }
+
+    default @NotNull T add(final @NotNull Direction direction) {
+        return this.add(direction, 1);
+    }
+
+    default @NotNull T north() {
+        return this.add(Direction.NORTH);
+    }
+
+    default @NotNull T east() {
+        return this.add(Direction.EAST);
+    }
+
+    default @NotNull T south() {
+        return this.add(Direction.SOUTH);
+    }
+
+    default @NotNull T west() {
+        return this.add(Direction.WEST);
+    }
+
+    default @NotNull T sub(final int x, final int z) {
+        return this.add(-x, -z);
+    }
+
+    default @NotNull T sub(final @NotNull T other) {
+        return this.sub(other.x(), other.z());
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/Pos3i.java b/game/core/src/main/java/net/minecraft/core/world/pos/Pos3i.java
new file mode 100644
index 000000000..e20595bd2
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/Pos3i.java
@@ -0,0 +1,58 @@
+package net.minecraft.core.world.pos;
+
+import net.minecraft.core.util.helper.Direction;
+import org.jetbrains.annotations.NotNull;
+
+public interface Pos3i<T extends Pos3i<T>> {
+    int x();
+
+    int y();
+
+    int z();
+
+    @NotNull T add(final int x, final int y, final int z);
+
+    default @NotNull T add(final @NotNull T other) {
+        return this.add(other.x(), other.y(), other.z());
+    }
+
+    default @NotNull T add(final @NotNull Direction direction, final int distance) {
+        return this.add(direction.getOffsetX() * distance, direction.getOffsetY() * distance, direction.getOffsetZ() * distance);
+    }
+
+    default @NotNull T add(final @NotNull Direction direction) {
+        return this.add(direction, 1);
+    }
+
+    default @NotNull T north() {
+        return this.add(Direction.NORTH);
+    }
+
+    default @NotNull T east() {
+        return this.add(Direction.EAST);
+    }
+
+    default @NotNull T south() {
+        return this.add(Direction.SOUTH);
+    }
+
+    default @NotNull T west() {
+        return this.add(Direction.WEST);
+    }
+
+    default @NotNull T up() {
+        return this.add(Direction.UP);
+    }
+
+    default @NotNull T down() {
+        return this.add(Direction.DOWN);
+    }
+
+    default @NotNull T sub(final int x, final int y, final int z) {
+        return this.add(-x, -y, -z);
+    }
+
+    default @NotNull T sub(final @NotNull T other) {
+        return this.sub(other.x(), other.y(), other.z());
+    }
+}
